function Y = FastSMTMultiply(FastSMTArray, FastSMTWeights, X)
% The function computes 
%          Y = diag(FastSMTWeights)*(SMT)*Y
%
% where FastSMTArray is an array of NumButterfly butterflies.

[N,M] = size(X);
Y = zeros(N,M);

[NumRotations,junk] = size(FastSMTArray);

for m=1:M
x = X(:,m);

for k=1:NumRotations
     i=FastSMTArray(k,1);
     j=FastSMTArray(k,2);
     a=FastSMTArray(k,3);
     b=FastSMTArray(k,4);

     xi = x(i) + x(j)*b;
     xj = x(i)*a + x(j);
     x(i)=xi;
     x(j)=xj;
end

Y(:,m) = FastSMTWeights.*x;
end



